PROGRAM VideoPoker ;

{ This is a video poker for time door.  This program is designed for use
  with RemoteAccess 2.00.  This program was written by John Parlin      }

USES DOS,CRT,jpglobal,ansiunit,JPDoor41,StrSup ;

CONST
   Version       = '1.03FW' ;

TYPE
   STR2     = STRING[2] ;
   DeckRec  = RECORD
                 CardNum   : STR2 ;
                 Suit      : CardSuit ;
              END ;
  JulRecord = Record
                LastRecordedDate : Real ;
              End ;


VAR
   cat1,cat2,
   cat3,cat4,
   cat5,cat6,
   cat7,cat8,
   cat9            : INTEGER ;
   CardDeck        : ARRAY [1..52] OF DeckRec ;
   InfoPath,
   ss,
   ConfigName,
   RatPath         : STRING ;
   CoinValue,
   MaxTurns,
   StartCoins,
   EndCoins,
   StartTime,
   Difference,
   TimePlayed,
   Winnings,
   ETime,
   STime,
   TurnCount,
   EndTime         : INTEGER ;
   PlayerHand      : ARRAY [1..5] OF DeckRec ;
   Held            : ARRAY [1..5] OF BOOLEAN ;
   MaxWinnings,
   Coins           : INTEGER ;
   Graphics,
   Holding         : CHAR ;
   Won,
   Registered,
   FlowControl,
   GameClosed      : BOOLEAN ;
   Year,
   Month,
   Date,
   Day             : WORD ;


PROCEDURE PollTerm ;
VAR
   timeout    : INTEGER ;
   Seconds    : INTEGER ;
   hr,mn,s,d  : WORD ;
   ACKStr     : STRING ;
   chx        : CHAR ;
BEGIN
   IF Local THEN BEGIN
      RIP := FALSE ;
      Exit ;
   END ;
   sDisplay(0,0,0,' ') ;
   sDisplay(0,0,0,#27+'[!') ;
   Timeout := 0 ;
   Seconds := 0 ;
   ACKStr := '' ;
   REPEAT
      GetTime(hr,mn,s,d) ;
      IF Seconds <> s THEN BEGIN
         INC(Timeout) ;
         Seconds := s ;
      END ;
      IF InReady THEN ACKstr := ACKStr + GetChar ;
   UNTIL (LENGTH(ACKStr) > 8) OR (Timeout > 3) ;
   IF POS('RIPSCRIP',ACKStr) > 0 THEN BEGIN
      RIP := TRUE ;
      if inready then begin
         repeat
            chx := getchar ;
         until not inready ;
      end ;
      Exit ;
   END ELSE BEGIN
      RIP := FALSE ;
      Exit ;
   END ;
END ;


FUNCTION Half(n:LONGINT) : LONGINT ;
BEGIN
   Half := Trunc((n DIV 2)) ;
   Exit ;
END ;


FUNCTION SpaceStr(instr:STRING) : STRING ;
VAR
   TempStr   : STRING ;
   ii        : INTEGER ;
   n         : INTEGER ;
BEGIN
   TempStr := '' ;
   n := 32 - LENGTH(instr) ;
   FOR ii := 1 TO n DO TempStr := TempStr + ' ' ;
   SpaceStr := TempStr ;
END ;


FUNCTION AtoI(Tstr:STRING) : INTEGER ;
VAR
   num,code    : INTEGER ;
BEGIN
   VAL(Tstr,num,code) ;
   IF code <> 0 THEN BEGIN
      AtoI := 0 ;
      EXIT ;
   END ELSE BEGIN
      AtoI := num ;
      EXIT ;
   END ;
END ;


FUNCTION Julian( year : integer; mon, day : byte): real;
VAR
  temp        : real;
BEGIN                                      { function Julian                 }
  if (year < 0) OR (mon < 1) OR (day < 1) OR (day > 31) then
    begin
      Julian := -1;
      exit;
    end;  { IF }
  if year < 100 then
    year := year + 1900;
  temp := int((mon - 14.0) / 12.0);
  Julian := day - 32075.0 +
            int(1461.0 * (year + 4800.0 + temp) / 4.0) +
            int(367.0 * (mon - 2.0 - temp * 12.0) / 12.0) -
            int(3.0 * int((year + 4900.0 + temp) / 100.0) / 4.0)
END ;


PROCEDURE RecordTurns ;
VAR
  TextFile      : Text ;
  NewFile       : Text ;
  Located       : Boolean ;
  NameStr       : String[35] ;
  Line          : String ;
BEGIN
  Assign(TextFile,'JPVP.TRN') ;
  {$I-} Reset(TextFile) ; {$I+}
  if ioresult <> 0 then begin
    Rewrite(TextFile) ;
    writeln(TextFile,UserName+':'+itoa(turncount)) ;
    close(TextFile) ;
    Exit ;
  end else begin
    assign(NewFile,'JPVPTURN.$$$') ;
    Rewrite(NewFile) ;
    while not eof(TextFile) do begin
      readln(TextFile,line) ;
      NameStr := copy(line,1,pos(':',line)-1) ;
      if NameStr <> UserName then writeln(NewFile,line) ;
    end ;
    close(TextFile) ;
    close(NewFile) ;
    erase(TextFile) ;
    rename(NewFile,'JPVP.TRN') ;
    Append(TextFile) ;
    writeln(TextFile,UserName+':'+itoa(TurnCount)) ;
    Close(TextFile) ;
  end ;
End ;


Procedure GetTurns ;
Var
  TextFile    : Text ;
  NameStr     : String[35] ;
  code        : INTEGER ;
  line        : STRING ;
Begin
  if not exist('JPVP.TRN') then exit ;
  Assign(TextFile,'JPVP.TRN') ;
  Reset(TextFile) ;
  While not eof(TextFile) do begin
    readln(TextFile,line) ;
    NameStr := copy(line,1,pos(':',line)-1) ;
    if NameStr = UserName then begin
      ss := copy(line,pos(':',line)+1,4) ;
      Val(ss,TurnCount,code) ;
    end ;
  end ;
  CLOSE(TextFile) ;
End ;


PROCEDURE CheckDates ;
VAR
  JulianRec     : FILE OF JulRecord ;
  Jul           : JulRecord ;
  TempFile      : TEXT ;
  TempReal      : REAL ;
  ErrFlag       : BOOLEAN ;
BEGIN
  ErrFlag := false ;
  GetDate(year,month,date,day) ;
  TempReal := Julian(year,month,date) ;

  ASSIGN(JulianRec,'JPVP.DTE') ;
  {$I-} Reset(JulianRec) ; {$I+}
  IF ioresult = 0 THEN BEGIN
    READ(JulianRec,Jul) ;
    ErrFlag := TempReal <> Jul.LastRecordedDate ;
    CLOSE(JulianRec) ;
  END ELSE ErrFlag := true ;
  IF ErrFlag THEN BEGIN
    Rewrite(JulianRec) ;
    Seek(JulianRec,0) ;
    Jul.LastRecordedDate := TempReal ;
    WRITE(JulianRec,Jul) ;
    CLOSE(JulianRec) ;
    ASSIGN(TempFile,'JPVP.TRN') ;
    IF Exist('JPVP.TRN') THEN ERASE(TempFile) ;
  END ;
END ;


PROCEDURE AdjustLog ;
Var
  LogFile    : Text ;
  LogCount   : Byte ;
  LogLine    : Array [1..10] of TextString ;
  i          : INTEGER ;
Begin
  if not exist('JPVP.HST') then exit ;
  LogCount := 0 ;
  Assign(LogFile,'JPVP.HST') ;
  Reset(LogFile) ;
  while not eof(LogFile) do begin
    LogCount := LogCount + 1 ;
    readln(LogFile,LogLine[LogCount]) ;
  end ;
  Close(LogFile) ;
  If LogCount = 0 then exit ;
  if LogCount >= 5 then begin
    Rewrite(LogFile) ;
    for i := 2 to 5 do writeln(LogFile,LogLine[i]) ;
    Flush(LogFile) ;
    Close(LogFile) ;
  end ;
End ;


PROCEDURE WriteLog(PlayerWon:BOOLEAN;HowMuch:INTEGER) ;
VAR
   y,m,dt,dy   : WORD ;
   Logfile     : TEXT ;
BEGIN
   AdjustLog ;
   IF ((PlayerWon) AND (HowMuch > 0)) THEN ss := ' won ' ELSE ss := ' lost ' ;
   GetDate(y,m,dt,dy) ;
   ASSIGN(Logfile,'JPVP.HST') ;
   IF EXIST('JPVP.HST') THEN APPEND(Logfile) ELSE REWRITE(Logfile) ;
   WRITELN(Logfile,FormatStr(UserName) + ss + StrC(HowMuch) + ' minutes') ;
   FLUSH(Logfile) ;
   CLOSE(Logfile) ;
END ;


PROCEDURE CloseGame ;
BEGIN
   IF NOT GameClosed THEN BEGIN
      RecordTurns ;
      EndCoins := Coins ;
      ETime := EndCoins * CoinValue ;
      STime := StartCoins * CoinValue ;
      TimePlayed := StartTime - TimeRemaining ;
      IF ETime > STime THEN BEGIN
         Difference := ETime - STime ;
         Won := TRUE ;
         Winnings := Difference - TimePlayed ;
         IncTime(Difference) ;
         WriteLog(TRUE,Winnings) ;
      END ELSE BEGIN
         Difference := STime - ETime ;
         Won := FALSE ;
         Winnings := Difference + TimePlayed ;
         DecTime(Difference) ;
         WriteLog(FALSE,Winnings) ;
      END ;
   END ;
END ;


PROCEDURE TinyFlag ;
BEGIN
   sDisplay(0,15,0,'This software was made in a small computer room in the USA ') ;
   sDisplay(1,15,0,'**') ;
   sDisplay(4,15,0,'') ;
   Display(0,15,0,' ') ;
END ;


PROCEDURE Comments ;
CONST
   tabstr  = '               ' ;
VAR
   ss      : STRING ;
   Deposit : INTEGER ;
   te      : INTEGER ;
BEGIN
   GameClosed := TRUE ;
   SetColor(0,7,0) ; sDisplay(0,7,0,' ') ;
   ClearScreen ;
   IF Won THEN ShowFile(0,0,0,'YOUWON','')
      ELSE ShowFile(0,0,0,'YOULOST','') ;
   CRLF ;
   Display(0,15,0,tabstr+'Here''s what you looked like on the house monitors:') ;
   Display(0,13,0,tabstr+'') ;
   sDisplay(0,11,0,tabstr+'Time you came in with: ') ;
   Display(0,15,0,itoa(STime)) ;
   sDisplay(0,11,0,tabstr+'Time you ended with:   ') ;
   Display(0,15,0,itoa(ETime)) ;
   IF Won THEN BEGIN
      sDisplay(0,11,0,tabstr+'Time you won:          ') ;
      Display(0,15,0,itoa(Difference)) ;
      sDisplay(0,11,0,tabstr+'Time spent playing:   -') ;
      Display(0,15,0,itoa(TimePlayed)) ;
      sDisplay(0,11,0,tabstr+'Total winnings:        ') ;
      Display(0,15,0,itoa(Winnings)) ;
   END ELSE BEGIN
      sDisplay(0,11,0,tabstr+'Time you lost:         ') ;
      Display(0,15,0,itoa(Difference)) ;
      sDisplay(0,11,0,tabstr+'Time spent playing:   -') ;
      Display(0,15,0,itoa(TimePlayed)) ;
      sDisplay(0,11,0,tabstr+'Total losses:          ') ;
      Display(0,15,0,itoa(Winnings)) ;
   END ;
   sDisplay(0,11,0,tabstr+'Adjusted time limit:   ') ;
   Display(0,15,0,itoa(TimeRemaining)) ;
   Display(0,13,0,tabstr+'') ;
   CRLF ;
   More('Press [any key] to continue',14) ;
   te := TimeToEvent ;
   IF TimeRemaining > TimeToEvent THEN BEGIN
      ClearScreen ;
      sDisplay(0,15,0,'There is a ') ;
      sDisplay(0,15,1,'SYSTEM EVENT') ;
      sDisplay(0,15,0,' in ') ;
      STR(TimeToEvent,ss) ;
      sDisplay(0,15,1,ss) ;
      Display(0,15,0,' minutes:') ;
      Display(0,13,0,'') ;
      sDisplay(0,14,0,'Your time remaining.................................. ') ;
      Display(0,15,0,Stri(TimeRemaining,4)) ;
      sDisplay(0,14,0,'Time to system event................................. ') ;
      Display(0,15,0,Stri(TimeToEvent,4)) ;
      sDisplay(0,14,0,'Time automatically deposited into your bank account.. ') ;
      Deposit := TimeRemaining - TimeToEvent ;
      Display(0,15,0,Stri(Deposit,4)) ;
      DepositTime(RatPath,UserName,Deposit) ;
      DecTime(Deposit) ;
      sDisplay(0,14,0,'Your adjusted time limit............................. ') ;
      Display(0,15,0,Stri(TimeRemaining,4)) ;
      CRLF ;
      More('Press [any key] to continue',12) ;
   END ;
   IF (TimeRemaining > MaxWinnings) AND (UserName <> SysopName) THEN
   BEGIN
      ClearScreen ;
      sDisplay(0,15,0,'You have exceeded the maximum allowed winnings of ') ;
      STR(MaxWinnings,ss) ;
      sDisplay(0,15,1,ss) ;
      Display(0,15,0,' minutes:') ;
      Display(0,13,0,'') ;
      sDisplay(0,14,0,'Your time remaining.................................. ') ;
      Display(0,15,0,Stri(TimeRemaining,4)) ;
      sDisplay(0,14,0,'Maximum winnings allowed............................. ') ;
      Display(0,15,0,Stri(MaxWinnings,4)) ;
      sDisplay(0,14,0,'Time automatically deposited into your bank account.. ') ;
      Deposit := TimeRemaining - MaxWinnings ;
      Display(0,15,0,Stri(Deposit,4)) ;
      DepositTime(RatPath,UserName,Deposit) ;
      DecTime(Deposit) ;
      sDisplay(0,14,0,'Your adjusted time limit............................. ') ;
      Display(0,15,0,Stri(TimeRemaining,4)) ;
      CRLF ;
      More('Press [any key] to continue',12) ;
   END ;
   setcolor(0,7,0) ;
   StatusLineOn := FALSE ;
   ClearScreen ;
   TinyFlag ;
   sDisplay(0,11,0,'Closing ') ;
   sdisplay(0,12,0,'Video Poker For Time ') ;
   sdisplay(0,11,0,'and returning to ') ;
   Display(0,9,0,SystemName) ;
   display(0,7,0,' ') ;
END ;


Procedure Terminate(n:byte) ;
{ This is an example procedure to handle the halt codes passed by
  TrapExit.  See the TrapExit.Pas file for more information on
  the codes returned and how they are passed to this procedure.
}
begin
  case n of
    0,15 : begin
          CloseGame ;
          Comments ;
        end ;
    1 : begin
          Writeln(' Carrier lost') ;
          CloseGame ;
        end ;
    2 : begin
          Writeln(' Time limit exceeded') ;
          CloseGame ;
        end ;
    3 : begin
          Writeln(' User inactive') ;
          CloseGame ;
        end ;
    4 : Writeln(' EXITINFO.BBS file not found!') ;
    5 : Writeln(' DORINFO1.DEF file not found!') ;
    7 : begin
           Writeln(' CTS Timeout') ;
           CloseGame ;
        end ;
    8 : begin
          StatusLineOn := FALSE ;
          SetColor(0,7,0) ;
          ClearScreen ;
          sDisplay(0,14,0,'Returning to ') ;
          Display(0,7,0,SystemName) ;
          Crlf ;
        End ;
    9 : begin
        end ;
    else CloseGame ;
  end ;
end ;


{$I JPVPExit}


PROCEDURE GetParms ;
BEGIN
   IF PARAMCOUNT = 0 THEN ConfigName := 'JPVP.CFG'
      ELSE ConfigName := ChangeCase(ParamStr(1)) ;
END ;


PROCEDURE GetConfig ;
VAR
   ConfigFile    : TEXT ;
   Line          : STRING ;
   num,code      : INTEGER ;
BEGIN
   MaxWinnings := 500 ;
   MaxTurns := 100 ;
   CoinValue := 2 ;
   cat1 := 5 ;
   cat2 := 15 ;
   cat3 := 20 ;
   cat4 := 25 ;
   cat5 := 30 ;
   cat6 := 35 ;
   cat7 := 50 ;
   cat8 := 70 ;
   cat9 := 90 ;
   IF NOT EXIST(ConfigName) THEN BEGIN
      WRITELN(#7,' Serious error: Cannot open configuration file: ',ConfigName) ;
      HALT(9) ;
   END ;
   ASSIGN(ConfigFile,ConfigName) ;
   RESET(ConfigFile) ;

   READLN(ConfigFile,Line) ; { path to exitinfo.bbs and dorinfo1.def }
   IF Line[LENGTH(line)] <> '\' THEN InfoPath := Line + '\'
     ELSE InfoPath := Line ;

   READLN(ConfigFile,Line) ; { path to RATS.EXE }
   IF Line[Length(line)] <> '\' THEN RatPath := Line + '\'
     ELSE RatPath := Line ;

   READLN(ConfigFile,Line) ; { get the node number in use but don't use it }

   READLN(ConfigFile,Line) ; { get coin value             }
   VAL(Line,num,code) ;
   IF (num<1) OR (num>10) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Coin value error, using default of 2') ;
   END ELSE CoinValue := num ;

   READLN(ConfigFile,Line) ; { get maximum turns }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Max turns error, using default of 100') ;
   END ELSE MaxTurns := num ;

   READLN(ConfigFile,Line) ;  { get max winnings }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Max winnings error, using default of 500') ;
   END ELSE MaxWinnings := num ;

   READLN(ConfigFile,Line) ;  { get payout for jacks or better }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for jacks or better, using default of ',cat1) ;
   END ELSE cat1 := num ;

   READLN(ConfigFile,Line) ;  { get payout for two pair }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for two pairs, using default of ',cat2) ;
   END ELSE cat2 := num ;

   READLN(ConfigFile,Line) ;  { get payout for three of a kind }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for three of a kind, using default of ',cat3) ;
   END ELSE cat3 := num ;

   READLN(ConfigFile,Line) ;  { get payout for a straight }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for a straight, using default of ',cat4) ;
   END ELSE cat4 := num ;

   READLN(ConfigFile,Line) ;  { get payout for a flush }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for a flush, using default of ',cat5) ;
   END ELSE cat5 := num ;

   READLN(ConfigFile,Line) ;  { get payout for a full house }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for a full house, using default of ',cat6) ;
   END ELSE cat6 := num ;

   READLN(ConfigFile,Line) ;  { get payout for four of a kind }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for four of a kind, using default of ',cat7) ;
   END ELSE cat7 := num ;

   READLN(ConfigFile,Line) ;  { get payout for a straight flush }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for a straight flush, using default of ',cat8) ;
   END ELSE cat8 := num ;

   READLN(ConfigFile,Line) ;  { get payout for a royal flush }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Payout for a royal flush, using default of ',cat9) ;
   END ELSE cat9 := num ;

   CLOSE(ConfigFile) ;
END ;

(***************************************************************************)

PROCEDURE WriteTimeStats ;
VAR
   i : INTEGER ;
BEGIN
   ETime := Coins * CoinValue ;
   STime := StartCoins * CoinValue ;
   TimePlayed := StartTime - TimeRemaining ;
   i := etime - stime ;
   cursorpos(17,33) ;
   sdisplay(0,11,0,rjust(itoa(starttime),6)) ;
   cursorpos(18,33) ;
   sdisplay(0,11,0,rjust(itoa(etime),6)) ;
   cursorpos(19,33) ;
   sdisplay(0,11,0,rjust(itoa(i),6)) ;
   cursorpos(20,33) ;
   sdisplay(0,11,0,rjust(itoa(timeplayed),6)) ;
END ;


PROCEDURE ClrCardWindow ;
VAR
   ii   : BYTE ;
BEGIN
   FOR ii := 6 TO 9 DO BEGIN
      Cursorpos(ii,21) ;
      sdisplay(0,7,0,MkString(36,#32)) ;
   END ;
END ;


PROCEDURE ClrMenuWindow ;
VAR
   ii   : BYTE ;
BEGIN
   FOR ii := 11 TO 20 DO BEGIN
      Cursorpos(ii,40) ;
      sdisplay(0,7,0,MkString(36,#32)) ;
   END ;
END ;


PROCEDURE WriteMenu ;
BEGIN
   ClrMenuWindow ;
   CursorPos(12,40) ;
   sdisplay(0,15,0,'[39m[4C[0;1;37;44m S E L E C T I O N  M E N U [40m') ;
   cursorpos(14,40) ;
   sdisplay(0,15,0,'[44m[9C[34;40m[[33mT[34m] [37mTake a Turn') ;
   cursorpos(15,40) ;
   sdisplay(0,15,0,'[9C[34m[[33mP[34m] [37mPayout Schedule') ;
   cursorpos(16,40) ;
   sdisplay(0,15,0,'[9C[34m[[33mL[34m] [37mLast Five Players') ;
   cursorpos(17,40) ;
   sdisplay(0,15,0,'[9C[34m[[33mQ[34m] [37mQuit to BBS') ;
   cursorpos(19,40) ;
   sdisplay(0,15,0,'[7C[33mYour Selection: [0m') ;
END ;


PROCEDURE ClrCmd ;
BEGIN
   CursorPos(19,63) ;
   sDisplay(0,15,0,'  ') ;
   CursorPos(19,63) ;
END ;


PROCEDURE ClrCardLine ;
BEGIN
   Cursorpos(9,21) ;
   sdisplay(0,7,0,MkString(37,#32)) ;
END ;


PROCEDURE WriteMsg(instr:STRING) ;
BEGIN
   ClrCardLine ;
   CursorPos(9,21) ;
   sDisplay(0,15,0,center(instr,37)) ;
END ;


PROCEDURE ClrIndicators ;
VAR
   jj,ii   : BYTE ;
BEGIN
   jj := 25 ;
   for ii := 1 to 5 do begin
      CursorPos(5,jj) ;
      sDisplay(0,15,0,' ') ;
      inc(jj,7) ;
   end ;
END ;


PROCEDURE ClrTime ;
BEGIN
   CursorPos(6,61) ;
   sDisplay(0,10,0,'              ') ;
END ;


PROCEDURE WriteTime ;
VAR
   sc   : STRING ;
   c    : INTEGER ;
BEGIN
   ClrTime ;
   c := Coins * CoinValue ;
   STR(c,sc) ;
   CursorPos(6,61) ;
   sDisplay(0,10,0,center(sc+' mins',14)) ;
   WriteTimeStats ;
END ;


PROCEDURE ClrCoins ;
BEGIN
   CursorPos(15,10) ;
   sDisplay(0,11,0,'          ') ;
END ;


PROCEDURE WriteCoins ;
VAR
   sc   : STRING ;
BEGIN
   ClrCoins ;
   STR(Coins,sc) ;
   CursorPos(15,10) ;
   sDisplay(0,11,0,center(sc,10)) ;
END ;


PROCEDURE ClrCoinValue ;
BEGIN
   CursorPos(15,24) ;
   sDisplay(0,11,0,'          ') ;
END ;


PROCEDURE WriteCoinValue ;
VAR
   sc   : STRING ;
BEGIN
   ClrCoinValue ;
   STR(CoinValue,sc) ;
   CursorPos(15,24) ;
   sDisplay(0,11,0,center(sc + ' mins',10)) ;
END ;


PROCEDURE ClrTurns ;
BEGIN
   CursorPos(12,10) ;
   sDisplay(0,11,0,'          ') ;
END ;


PROCEDURE WriteTurns ;
VAR
   sc   : STRING ;
BEGIN
   ClrTurns ;
   STR(TurnCount,sc) ;
   CursorPos(12,10) ;
   sDisplay(0,11,0,center(sc,10)) ;
END ;


PROCEDURE ClrMaxTurns ;
BEGIN
   CursorPos(12,24) ;
   sDisplay(0,11,0,'          ') ;
END ;


PROCEDURE WriteMaxTurns ;
VAR
   sc   : STRING ;
BEGIN
   ClrMaxTurns ;
   STR(MaxTurns,sc) ;
   CursorPos(12,24) ;
   sDisplay(0,11,0,center(sc,10)) ;
END ;


PROCEDURE DrawScreen ;
BEGIN
   SetColor(0,7,0) ;
   ClearScreen ;
   ShowFile(15,0,0,'JPVP.ANS','') ;
   WriteCoinValue ;
   WriteTurns ;
   WriteMaxTurns ;
END ;


PROCEDURE ShuffleDeck ;
VAR
   counter : INTEGER ;
BEGIN
   counter := 0 ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'A' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'A' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'A' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'A' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '2' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '2' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '2' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '2' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '3' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '3' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '3' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '3' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '4' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '4' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '4' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '4' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '5' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '5' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '5' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '5' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '6' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '6' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '6' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '6' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '7' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '7' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '7' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '7' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '8' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '8' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '8' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '8' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '9' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '9' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '9' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '9' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := '10' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := '10' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := '10' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := '10' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'J' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'J' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'J' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'J' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'Q' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'Q' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'Q' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'Q' ;
   CardDeck[counter].Suit := S ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'K' ;
   CardDeck[counter].Suit := C ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'K' ;
   CardDeck[counter].Suit := D ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'K' ;
   CardDeck[counter].Suit := H ;
   INC(counter) ;
   CardDeck[counter].CardNum := 'K' ;
   CardDeck[counter].Suit := S ;
END ;


PROCEDURE InitPlayerHand ;
VAR
   jj     : BYTE ;
BEGIN
   FOR jj := 1 TO 5 DO BEGIN
      PlayerHand[jj].cardnum := ' ' ;
      PlayerHand[jj].suit := H ;
   END ;
END ;


PROCEDURE Win(n:integer) ;
VAR
   w   : INTEGER ;
   ts  : STRING ;
BEGIN
   ClrCardLine ;
   ClrIndicators ;
   cursorpos(9,21) ;
   if n = cat9 then ts := 'Royal Flush--'
     else
   if n = cat8 then ts := 'Straight Flush--'
     else
   if n = cat7 then ts := '4 of a Kind--'
     else
   if n = cat6 then ts := 'Full House--'
     else
   if n = cat5 then ts := 'Flush--'
     else
   if n = cat4 then ts := 'Straight--'
     else
   if n = cat3 then ts := '3 of a Kind--'
     else
   if n = cat2 then ts := '2 Pairs--'
     else
   if n = cat1 then ts := 'Jacks or Better--'
     else ts := '' ;
   sdisplay(0,10,1,center(ts+'Paying out '+itoa(n),37)) ;
   for w := 1 to n do begin
      inc(coins) ;
      if coins mod 10 = 0 then begin
         writecoins ;
         delay(300) ;
      end ;
   end ;
   writecoins ;
   WriteTime ;
END ;


FUNCTION FoundCard(St:Str2) : BOOLEAN ;
VAR
   k    : BYTE ;
BEGIN
   for k := 1 to 5 do begin
      if playerhand[k].cardnum = St then begin
         FoundCard := true ;
         exit ;
      end ;
   end ;
   foundcard := false ;
END ;


FUNCTION SameSuit : BOOLEAN ;
VAR
   ii       : BYTE ;
   LastSuit : CardSuit ;
   tb       : BOOLEAN ;
BEGIN
   tb := true ;
   for ii := 1 to 5 do begin
      if ii = 1 then lastsuit := playerhand[ii].suit ;
      if playerhand[ii].suit <> lastsuit then tb := false ;
   end ;
   if tb then begin
      SameSuit := true ;
      exit ;
   end ;
   SameSuit := false ;
END ;


FUNCTION RoyalFlush : BOOLEAN ;
BEGIN
   if (foundcard('A')) and (foundcard('K')) and (foundcard('Q'))
   and (foundcard('J')) and (foundcard('10')) then begin
      if SameSuit then begin
         RoyalFlush := true ;
         exit ;
      end ;
   end ;
   RoyalFlush := false ;
END ;


FUNCTION CardVal(c:BYTE) : INTEGER ;
VAR
   ii      : INTEGER ;
BEGIN
   if playerhand[c].cardnum = 'A' then ii := 1
     else
   if playerhand[c].cardnum = 'K' then ii := 13
     else
   if playerhand[c].cardnum = 'Q' then ii := 12
     else
   if playerhand[c].cardnum = 'J' then ii := 11
     else
   if playerhand[c].cardnum = '10' then ii := 10
     else
   ii := atoi(playerhand[c].cardnum) ;
   CardVal := ii ;
END ;


FUNCTION HasVal(i:BYTE) : BOOLEAN ;
VAR
   ii   : BYTE ;
BEGIN
   for ii := 1 to 5 do begin
      if cardval(ii) = i then begin
         HasVal := true ;
         exit ;
      end ;
   end ;
   HasVal := false ;
END ;


FUNCTION HasStraight : BOOLEAN ;
VAR
   l,ii      : BYTE ;
BEGIN
   { check for ace high straight }
   if (hasval(10)) and (hasval(11)) and (hasval(12)) and (hasval(13))
   and (hasval(1)) then begin
      HasStraight := true ;
      exit ;
   end ;

   {find the lowest card}
   l := 14 ;
   for ii := 1 to 5 do begin
      if cardval(ii) < l then
        l := cardval(ii) ;
   end ;
   { lowest card value is "l" }
   if l < 10 then begin
      if (hasval(l+1)) and (hasval(l+2)) and (hasval(l+3))
      and (hasval(l+4)) then begin
         HasStraight := true ;
         exit ;
      end ;
   end ;
   HasStraight := false ;
END ;


FUNCTION StraightFlush : BOOLEAN ;
BEGIN
   if (HasStraight) and (SameSuit) then StraightFlush := true
      else
   StraightFlush := false ;
END ;


FUNCTION CardCount(n:byte) : BYTE ;
VAR
   c      : BYTE ;
   ii     : BYTE ;
BEGIN
   c := 0 ;
   for ii := 1 to 5 do begin
      if cardval(ii) = n then inc(c) ;
   end ;
   CardCount := c ;
END ;


FUNCTION FourOfAKind : BOOLEAN ;
VAR
   ii     : BYTE ;
   tb     : BOOLEAN ;
BEGIN
   tb := false ;
   for ii := 1 to 5 do begin
      if cardcount(cardval(ii)) = 4 then begin
         FourOfAKind := true ;
         exit ;
      end ;
   end ;
   FourOfAKind := false ;
END ;


FUNCTION ThreeOfAKind : BOOLEAN ;
VAR
   ii     : BYTE ;
BEGIN
   for ii := 1 to 5 do begin
      if cardcount(cardval(ii)) = 3 then begin
         ThreeOfAKind := true ;
         exit ;
      end ;
   end ;
   ThreeOfAKind := false ;
END ;


FUNCTION FullHouse : BOOLEAN ;
VAR
   ii     : BYTE ;
   cc     : BYTE ;
BEGIN
   if ThreeOfAKind then begin
      { find the card that is the triple }
      for ii := 1 to 5 do begin
         if cardcount(cardval(ii)) = 3 then begin
            cc := cardval(ii) ;
         end ;
         { cc is the value of the triple }
      end ;
      for ii := 1 to 5 do begin
         if cardval(ii) = cc then begin
            playerhand[ii].cardnum := 'U' ;
         end ;
      end ;
      { triple is now blanked out of hand }
      for ii := 1 to 5 do begin
         if (playerhand[ii].cardnum <> 'U')
         and (cardcount(cardval(ii)) = 2) then begin
            FullHouse := true ;
            exit ;
         end ;
      end ;
   end ;
   FullHouse := false ;
END ;


FUNCTION Flush : BOOLEAN ;
BEGIN
   if SameSuit then Flush := true else Flush := false ;
END ;


FUNCTION Straight : BOOLEAN ;
BEGIN
   if HasStraight then Straight := true else Straight := false ;
END ;


FUNCTION TPair : BOOLEAN ;
VAR
   ii : BYTE ;
   c  : BYTE ;
BEGIN
   for ii := 1 to 5 do begin
      if cardcount(cardval(ii)) = 2 then begin
         TPair := true ;
         exit ;
      end ;
   end ;
   TPair := false ;
END ;


FUNCTION Pair : BOOLEAN ;
VAR
   ii : BYTE ;
BEGIN
   if TPair then begin
      for ii := 1 to 5 do begin
         if (cardcount(cardval(ii)) = 2) and
         ((cardval(ii) > 10) or (cardval(ii) = 1)) then begin
            Pair := true ;
            exit ;
         end ;
      end ;
   end ;
   Pair := false ;
END ;


FUNCTION TwoPair : BOOLEAN ;
VAR
   ii,cc   : BYTE ;
   tdeck   : ARRAY [1..5] of DeckRec ;
BEGIN
   if TPair then begin
      { save the player's hand for further comparison }
      for ii := 1 to 5 do begin
         tdeck[ii].cardnum := playerhand[ii].cardnum ;
         tdeck[ii].suit := playerhand[ii].suit ;
      end ;
      { find the card that is the pair }
      for ii := 1 to 5 do begin
         if cardcount(cardval(ii)) = 2 then begin
            cc := cardval(ii) ;
         end ;
         { cc is the value of the pair }
      end ;
      for ii := 1 to 5 do begin
         if cardval(ii) = cc then begin
            playerhand[ii].cardnum := 'U' ;
         end ;
      end ;
      { pair is now blanked out of hand }
      for ii := 1 to 5 do begin
         if (playerhand[ii].cardnum <> 'U')
         and (cardcount(cardval(ii)) = 2) then begin
            TwoPair := true ;
            exit ;
         end ;
      end ;
      { restore the player's hand for further comparison }
      for ii := 1 to 5 do begin
         playerhand[ii].cardnum := tdeck[ii].cardnum ;
         playerhand[ii].suit := tdeck[ii].suit ;
      end ;
   end ;
   TwoPair := false ;
END ;


PROCEDURE TallyHand ;
VAR
   ii    : BYTE ;
BEGIN
   if RoyalFlush then begin
      Win(cat9) ;
   end else if StraightFlush then begin
      Win(cat8) ;
   end else if FourOfAKind then begin
      Win(cat7) ;
   end else if FullHouse then begin
      Win(cat6) ;
   end else if Flush then begin
      Win(cat5) ;
   end else if Straight then begin
      Win(cat4) ;
   end else if ThreeOfAKind then begin
      Win(cat3) ;
   end else if TwoPair then begin
      Win(cat2) ;
   end else if Pair then begin
      Win(cat1) ;
   end else begin
      ClrIndicators ;
      ClrCardLine ;
      cursorpos(9,21) ;
      sdisplay(0,12,0,center('Nothing---You lose!',37)) ;
   end ;
END ;


PROCEDURE WriteIndicator(last,this:byte) ;
BEGIN
   if last <> 0 then begin
      case last of
         1 : cursorpos(5,25) ;
         2 : cursorpos(5,32) ;
         3 : cursorpos(5,39) ;
         4 : cursorpos(5,46) ;
         5 : cursorpos(5,53) ;
      end ;
      if held[last] then sdisplay(0,15,0,'H')
         else sdisplay(0,15,0,' ') ;
   end ;
   case this of
      1 : cursorpos(5,25) ;
      2 : cursorpos(5,32) ;
      3 : cursorpos(5,39) ;
      4 : cursorpos(5,46) ;
      5 : cursorpos(5,53) ;
   end ;
   if held[this] then sdisplay(0,14,0,'H') else sdisplay(0,14,0,'') ;
END ;


PROCEDURE HoldOrDraw ;
VAR
   k                : BYTE ;
   currentposition,
   lastposition     : BYTE ;
   cch              : CHAR ;
BEGIN
   for k := 1 to 5 do held[k] := false ;
   WriteMsg('SPACE to hold card, ENTER to draw') ;
   currentposition := 1 ;
   lastposition := 1 ;
   WriteIndicator(0,1) ;
   repeat
      repeat
         cch := getchar ;
      until cch in ['4','6','5',#32,#13] ;
      case cch of
         '4' : begin
                  if currentposition = 1 then
                     currentposition := 5 else dec(currentposition) ;
                  WriteIndicator(lastposition,currentposition) ;
                  lastposition := currentposition ;
               end ;
         '6' : begin
                  if currentposition = 5 then
                     currentposition := 1 else inc(currentposition) ;
                  WriteIndicator(lastposition,currentposition) ;
                  lastposition := currentposition ;
               end ;
         '5',
         #32 : begin
                  if held[currentposition] then
                     held[currentposition] := false
                  else
                     held[currentposition] := true ;
                  WriteIndicator(0,currentposition) ;
               end ;
      end ;
   until cch = #13 ;
END ;


PROCEDURE TakeTurn ;
VAR
   r    : integer ;
   cc   : BYTE ;
   tt   : BYTE ;
   done : BOOLEAN ;
BEGIN
   if turncount >= MaxTurns then begin
      WriteMsg('Your turn is over for today!');
      exit ;
   end ;
   if Coins < 6 then begin
      WriteMsg('You need at least 6 coins to gamble!') ;
      exit ;
   end ;
   inc(TurnCount) ;
   WriteTurns ;
   ClrCardLine ;
   DEC(Coins,5) ;
   WriteCoins ;
   WriteTime ;
   ClrIndicators ;
   ClrCardWindow ;
   ShuffleDeck ;
   InitPlayerHand ;

   cc := 1 ;
   repeat
      repeat
         r := random(255) ;
      until (r > 0) and (r < 53) ;
      if CardDeck[r].cardnum <> 'U' then begin
         playerhand[cc].cardnum := CardDeck[r].cardnum ;
         playerhand[cc].suit := CardDeck[r].suit ;
         CardDeck[r].cardnum := 'U' ;
         inc(cc) ;
      end ;
   until cc = 6 ;
   cc := 23 ;
   for r := 1 to 5 do begin
      DrawCard(playerhand[r].CardNum,playerhand[r].Suit,6,cc,7,false) ;
      inc(cc,7) ;
      delay(500) ;
   end ;
   HoldOrDraw ;
   { now deal cards to positions not held }
   for cc := 1 to 5 do begin
      if not held[cc] then begin
         tt := 16 ;
         tt := tt + (cc * 7) ;
         cursorpos(6,tt) ;
         display(0,15,0,'     ') ;
         cursorpos(7,tt) ;
         display(0,15,0,'     ') ;
         cursorpos(8,tt) ;
         display(0,15,0,'     ') ;
      end ;
   end ;


   for cc := 1 to 5 do begin
      if not held[cc] then begin
         done := false ;
         repeat
            r := random(255) ;
            if (r > 1) and (r < 53) then begin
               if CardDeck[r].cardnum <> 'U' then begin
                  PlayerHand[cc].cardnum := CardDeck[r].cardnum ;
                  PlayerHand[cc].suit := CardDeck[r].suit ;
                  CardDeck[r].cardnum := 'U' ;
                  done := true ;
                  DrawCard(playerhand[cc].CardNum,playerhand[cc].Suit,6,16+(cc*7),7,false) ;
                  delay(500) ;
               end ;
            end ;
         until done ;
      end ;
   end ;
   { now tally up the hand }
   TallyHand ;
END ;


PROCEDURE MenuAgent ;
VAR
   Choice      : CHAR ;
   Logfile     : TEXT ;
   logline     : STRING ;
   bwc,
   ii          : INTEGER ;
BEGIN
   REPEAT
      ClrCmd ;
      REPEAT
         Choice := upcase(GetChar) ;
         if choice = #13 then choice := 'T' ;
      UNTIL Choice IN ['R','T','P','L','Q'] ;
      SetHotKeys_OFF ;
      CASE Choice OF
         'P' : BEGIN
                  ClrMenuWindow ;
                  cursorpos(11,40) ;
                  sdisplay(0,12,0,center('Payout Schedule',36)) ;
                  cursorpos(12,40) ;
                  sdisplay(0,7,0,center('Jacks or Better pays '+itoa(cat1),36)) ;
                  cursorpos(13,40) ;
                  sdisplay(0,7,0,center('Two Pair pays '+itoa(cat2),36)) ;
                  cursorpos(14,40) ;
                  sdisplay(0,7,0,center('Three of a Kind pays '+itoa(cat3),36)) ;
                  cursorpos(15,40) ;
                  sdisplay(0,7,0,center('A Straight pays '+itoa(cat4),36)) ;
                  cursorpos(16,40) ;
                  sdisplay(0,7,0,center('A Flush pays '+itoa(cat5),36)) ;
                  cursorpos(17,40) ;
                  sdisplay(0,7,0,center('A Full House pays '+itoa(cat6),36)) ;
                  cursorpos(18,40) ;
                  sdisplay(0,7,0,center('Four of a Kind pays '+itoa(cat7),36)) ;
                  cursorpos(19,40) ;
                  sdisplay(0,7,0,center('A Straight Flush pays '+itoa(cat8),36)) ;
                  cursorpos(20,40) ;
                  sdisplay(0,7,0,center('A Royal Flush pays '+itoa(cat9),36)) ;
                  WriteMsg('Press ENTER to continue') ;
                  repeat
                     holding := getchar ;
                  until holding = #13 ;
                  ClrCardLine ;
                  WriteMenu ;
               END ;
         'L' : BEGIN
                  IF (EXIST('JPVP.HST')) AND (SizeFile('JPVP.HST') > 0) THEN BEGIN
                     ASSIGN(Logfile,'JPVP.HST') ;
                     RESET(Logfile) ;
                     ClrMenuWindow ;
                     CursorPos(11,40) ;
                     sDisplay(0,3,0, '  ͸͸͸  ͸    ͸') ;
                     CursorPos(12,40) ;
                     sDisplay(0,11,0,'   ͵͸            վ   ') ;
                     CursorPos(13,40) ;
                     sDisplay(0,15,0,';  ;          ;  ;') ;
                     FOR ii := 1 TO 5 DO BEGIN
                        READLN(Logfile,logline) ;
                        CASE ii OF
                           1 : CursorPos(14,40) ;
                           2 : CursorPos(15,40) ;
                           3 : CursorPos(16,40) ;
                           4 : CursorPos(17,40) ;
                           5 : CursorPos(18,40) ;
                        END ;
                        CASE ii OF
                           1 : bwc := 5 ;
                           2 : bwc := 4 ;
                           3 : bwc := 3 ;
                           4 : bwc := 2 ;
                           5 : bwc := 1 ;
                        END ;
                        IF ODD(ii) THEN
                           sDisplay(3,15,0,' ' + StrC(bwc) + '. ' + logline + SpaceStr(logline))
                        ELSE
                           sDisplay(1,15,0,' ' + StrC(bwc) + '. ' + logline + SpaceStr(logline)) ;
                     END ;
                     CLOSE(Logfile) ;
                     CursorPos(20,40) ;
                     sdisplay(0,12,0,center('Press [any key] to continue',36)) ;
                     Holding := GetChar ;
                     ClrCardLine ;
                     ClrMenuWindow ;
                     WriteMenu ;
                     WriteTurns ;
                     WriteMaxTurns ;
                     WriteCoins ;
                     WriteCoinValue ;
                     WriteTime ;
                  END ELSE WriteMsg('The log file is empty.') ;
               END ;
         'T' : BEGIN
                  TakeTurn ;
               END ;
         'R' : BEGIN
                  StatusLineOn := FALSE ;
                  Show_status ;
                  DrawScreen ;
                  WriteCoins ;
                  WriteTime ;
                  WriteMenu ;
                  StatusLineOn := TRUE ;
                  Show_Status ;
               END ;
      END ;
   UNTIL Choice IN ['E','Q'] ;
   WriteMsg('Come back soon!') ;
   HALT(0) ;
END ;


PROCEDURE InitVars ;
BEGIN
   Registered := FALSE ;
   InfoPath := '' ;
   RatPath := '' ;
   TurnCount := 0 ;
   GameClosed := TRUE ;
   Winnings := 0 ;
END ;


PROCEDURE SetClub ;
VAR
   Choice    : CHAR ;
BEGIN
   CRLF ;
   Display(0,7,0,'Some communications programs do not display the CLUB character') ;
   Display(0,7,0,'properly.  If you are using one of these communications programs,') ;
   Display(0,7,0,'the CLUB character will not be visible in the prompt below.  If') ;
   Display(0,7,0,'this is the case, then answer No to the prompt.') ;
   CRLF ;
   sDisplay(0,15,0,'Do you see a CLUB character between the arrows? ') ;
   sDisplay(0,14,0,'> ') ;
   sDisplay(0,12,0,ClubChar) ;
   sDisplay(0,14,0,' <') ;
   sDisplay(0,15,0,' (Y,n): ') ;
   REPEAT
      Choice := UPCASE(GetChar) ;
      IF Choice = #13 THEN Choice := 'Y' ;
   UNTIL Choice IN ['Y','N'] ;
   sDisplay(0,15,0,Choice) ;
   IF Choice = 'N' THEN ClubChar := 'C' ;
END ;


PROCEDURE SendOut(disp:textstring) ;
var
   k   : byte ;
begin
   if local then exit ;
   chkconnect ;
   for k := 1 to Length(disp) do CharOut(disp[k]) ;
   CharOut(#13) ;
   CharOut(#10) ;
   chkconnect ;
end ;



BEGIN                                 (*   M A I N   *)
   randomize ;
   InitVars ;
   DoorExit := TrapExit ;
   CkMsgs := FALSE ;
   GetParms ;
   GetConfig ;
   ShowWindow := false ;
   ProductName := 'VideoPoker '+Version ;
   GetDorinfo(node,InfoPath) ;
   IF Not SetFossil THEN BEGIN END ;
   UserName := ChangeCase(UserName) ;
   SysopName := ChangeCase(SysopName) ;
   SystemName := ChangeCase(SystemName) ;
   SetColor(0,7,0) ;
   PollTerm ;
   if rip then
   begin
      crlf ;
      sendout('!|1K|*|w0000270O12|10000$COFF$|#|#|#') ;
   end ;
   if ansi < 1 then begin
      crlf ;
      display(0,7,0,'This game requires ANSI emulation.  Continue? (Y,n): ') ;
      repeat
         holding := upcase(getchar) ;
         if holding = #13 then holding := 'Y' ;
      until holding in ['Y','N'] ;
      display(0,15,0,holding) ;
      if holding = 'N' then halt(9) ;
      ansi := 1 ;
   end ;
   IF TimeRemaining < 5 THEN BEGIN
      CRLF ;
      Display(0,15,0,'You do not have enough time left to play Video Poker For Time!') ;
      HALT(9) ;
   END ;

   GameClosed := FALSE ;
   SetClub ;
   ClearScreen ;
   ShowFile(15,0,0,'JPVPOPEN','') ;
   Holding := upcase(GetChar) ;
   SetColor(0,7,0) ; sDisplay(0,7,0,' ') ;
   ClearScreen ;
   Display(0,15,0,' ') ;
   Display(0,15,0,Center('Video Poker For Time - Version ' + Version,79)) ;
   Display(0,15,0,Center('Copyright 1995 John Parlin',79)) ;
   Display(0,15,0,Center('All rights reserved',79)) ;
   CRLF ;

   Registered := TRUE ;
   Display(0,14,0,Center('Registered to '+ChangeCase(SysopName)+' of '+
                  ChangeCase(SystemName),79)) ;
   STR(TimeToEvent,ss) ;
   CRLF ;
   Display(0,15,0,Center('Next System Event is in ' + ss + ' minutes.',79)) ;
   CRLF ;
   sDisplay(0,13,0,Center('Press [any key] to continue',79)) ;
   holding := getchar ;
   CheckDates ;
   GetTurns ;
   IF ODD(TimeRemaining) THEN INC(TimeRemaining) ;
   DrawScreen ;
   StatusLineOn := TRUE ;
   Show_Status ;
   WriteMenu ;
   StartTime := TimeRemaining ;
   Coins := StartTime DIV CoinValue ;
   StartCoins := Coins ;
   WriteTime ;
   WriteCoins ;
   MenuAgent ;
END.
