UNIT strsup;

INTERFACE

TYPE
   charset  = SET OF #0..#255 ;
   STR2     = STRING[2] ;
   STR7     = STRING[7] ;


CONST
		 hialpha  : charset = ['A'..'Z'];
		 loalpha  : charset = ['a'..'z'];
		 digits   : charset = ['0'..'9'];
		 puncset  : charset = ['!'..'/','['..'''','{'..'~'];

FUNCTION hex(n:Word):STRING;
FUNCTION bin(n:Word):STRING;
FUNCTION stri(n:LongInt;width:Byte):STRING;
FUNCTION FixByte(n:WORD):STR2 ;
FUNCTION Strn(n:LongInt) : STR7 ;
(* FUNCTION strr(n:single;width,decimals:Byte):STRING; *)
FUNCTION tabstr(instr : STRING;n:Byte):STRING;
FUNCTION rjstr(instr:STRING;width:Byte):STRING;
FUNCTION triml(instr:STRING):STRING;
FUNCTION trimr(instr:STRING):STRING;
FUNCTION trimall(instr:STRING):STRING;
FUNCTION strupcase(instr:STRING):STRING;
FUNCTION lowcase(ch:Char):Char;
FUNCTION capfirst(instr:STRING;stripchars:charset):STRING;
FUNCTION wrapstr(VAR instr:STRING;addstr:STRING;l:Byte):STRING;
FUNCTION validate(instr:string;checkchars:charset):BOOLEAN;
FUNCTION codelower(instr:STRING):STRING;
FUNCTION strc(ii:LONGINT) : STRING ;

var FILLCH : CHAR;
    SHOWSIGN : BOOLEAN;
    NEGSOFF  : BOOLEAN;

IMPLEMENTATION



FUNCTION StrC(ii:LONGINT) : STRING ;
VAR
   TempString : STRING ;
BEGIN
   STR(ii,TempString) ;
   StrC := TempString ;
END ;

FUNCTION hex(n:Word):STRING;
CONST digits : ARRAY [0..15] OF Char='0123456789ABCDEF';
BEGIN
	hex:=digits[Hi(n) shr 4]+digits[Hi(n) AND $f] +
			 digits[Lo(n) shr 4]+digits[Lo(n) AND $f];
END;

FUNCTION bin(n:Word):STRING;
CONST digits : ARRAY [0..15] OF STRING[4]=('0000','0001','0010','0011',
																					 '0100','0101','0110','0111',
																					 '1000','1001','1010','1011',
																					 '1100','1101','1110','1111');
BEGIN
	bin:=digits[Hi(n) shr 4]+digits[Hi(n) AND $f] +
			 digits[Lo(n) shr 4]+digits[Lo(n) AND $f];
END;


FUNCTION stri;
VAR temp : STRING;
    i    : byte;
BEGIN
	Str(n:width,temp);
	if (length(temp)>width) and (width>0) then temp:=rjstr('ERROR',width);
  if n<0 then inc(width);
  for i:=1 to length(temp) do if temp[i]=' ' then temp[i]:=fillch;
  if showsign then
  begin
    if pos('-',temp)>0 then
    begin
      temp[pos('-',temp)]:=fillch;
      temp:='-'+temp
    end
    else
      temp:='+'+temp
  end;
  if negsoff and (pos('-',temp)>0) then temp:=tabstr('',width);
  showsign:=false;
	stri:=temp
END;

FUNCTION FixByte(n:WORD) : STR2 ;
VAR
   temp    : STR2 ;
   solve   : STR2 ;
BEGIN
   STR(n,temp) ;
   CASE n OF
      0..9 : solve := CONCAT('0',temp) ;
      ELSE solve := temp ;
   END ;
   FixByte := solve ;
END ;

FUNCTION Strn(n:LONGINT) : STR7 ;
VAR
   temp   : STR7 ;
BEGIN
   STR(n,temp) ;
   Strn := temp ;
END ;

(* FUNCTION strr;
VAR temp : STRING;
    i    : byte;
BEGIN
	Str(n:width:decimals,temp);
	if (length(temp)>width) and (width>0) then temp:=rjstr('ERROR',width);
  if n<0.0 then inc(width);
  for i:=1 to length(temp) do if temp[i]=' ' then temp[i]:=fillch;
  if showsign then
  begin
    if pos('-',temp)>0 then
    begin
      temp[pos('-',temp)]:=fillch;
      temp:='-'+temp
    end
    else
      temp:='+'+temp
  end;
  if negsoff and (pos('-',temp)>0) then temp:=tabstr('',width);
  showsign:=false;
	strr:=temp
END;      *)

FUNCTION tabstr;
VAR temp : STRING;
BEGIN
	temp[0]:=Chr(n);
	FillChar(temp[1],n,fillch);
	Move(instr[1],temp[1],Length(instr));
	tabstr:=temp
END;

FUNCTION lowcase;
BEGIN
	IF ch IN ['A'..'Z'] THEN ch:=Chr(Ord(ch)+32);
	lowcase:=ch
END;

FUNCTION trimr;
BEGIN
	WHILE (Length(instr)>0) AND (instr[Length(instr)]=' ') DO
		instr[0]:=Pred(instr[0]);
	trimr:=instr
END;

FUNCTION triml;
BEGIN
	WHILE (Length(instr)>0) AND (instr[1]=' ') DO
		instr:=Copy(instr,2,Length(instr)-1);
	triml:=instr
END;

FUNCTION trimall;
BEGIN
	WHILE Pos('  ',instr)>0 DO Delete(instr,Pos('  ',instr),1);
	instr:=triml(trimr(instr));
	trimall:=instr
END;

FUNCTION strupcase;
VAR i : Byte;
BEGIN
	FOR i:=1 TO Length(instr) DO instr[i]:=UpCase(instr[i]);
	strupcase:=instr
END;

FUNCTION capfirst;
VAR i : Byte;
		s : Boolean;
BEGIN
	FOR i:=1 TO Length(instr) DO
		IF NOT (instr[i] IN stripchars) THEN instr[i]:=' ';
	instr:=trimall(instr);
	s:=true;
	FOR i:=1 TO Length(instr) DO
	BEGIN
		IF s THEN
			instr[i]:=UpCase(instr[i])
		ELSE
			instr[i]:=lowcase(instr[i]);
		s:=(instr[i]=' ')
	END;
	capfirst:=instr
END;

FUNCTION rjstr;
VAR temp : STRING;
BEGIN
	Move(instr[1],temp[1],Length(instr));
	IF Length(instr)>width THEN
		temp[0]:=Chr(width)
	ELSE
	BEGIN
		temp[0]:=Chr(width);
		Move(temp[1],temp[(width-Length(instr))+1],Length(instr));
		FillChar(temp[1],width-Length(instr),' ')
	END;
	rjstr:=temp
END;


FUNCTION wrapstr;
VAR temp : STRING;
		i,j  : Integer;
BEGIN
	i:=(Length(instr)+Length(addstr))-l;
	IF i>0 THEN
	BEGIN
		j:=Length(addstr)-i;
		WHILE (j>0) AND (addstr[j] IN hialpha+loalpha+digits) DO Dec(j);
		Inc(j);
		temp:=Copy(addstr,j,Length(addstr)-j+1);
		addstr[0]:=Chr(j-1);
		instr:=instr+addstr
	END
	ELSE
	BEGIN
		temp:='';
		instr:=instr+addstr
	END;
	wrapstr:=temp
END;

FUNCTION validate;
var i : byte;
begin
  validate:=true;
  for i:=1 to length(instr) do
  begin
    if not (instr[i] in checkchars) then
    begin
      validate:=false;
      exit
    end
  end
end;

FUNCTION codelower;
VAR i     : Byte;
		quote : Boolean;
BEGIN
	quote:=false;
	FOR i:=1 TO Length(instr) DO
	BEGIN
		IF instr[i]='''' THEN quote:=NOT quote;
		IF NOT quote THEN instr[i]:=lowcase(instr[i])
	END;
	codelower:=instr
END;
BEGIN
  FILLCH:=' ';
  SHOWSIGN:=FALSE;
  NEGSOFF:=FALSE;
END.
